package cn.ibizlab.humanresource.core.humanresource.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.humanresource.domain.HRPaper;
import cn.ibizlab.humanresource.core.humanresource.filter.HRPaperSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRPaper] 服务对象接口
 */
public interface IHRPaperService extends IService<HRPaper>{

    boolean create(HRPaper et) ;
    void createBatch(List<HRPaper> list) ;
    boolean update(HRPaper et) ;
    void updateBatch(List<HRPaper> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRPaper get(String key) ;
    HRPaper getDraft(HRPaper et) ;
    boolean checkKey(HRPaper et) ;
    boolean save(HRPaper et) ;
    void saveBatch(List<HRPaper> list) ;
    Page<HRPaper> searchDefault(HRPaperSearchContext context) ;
    List<HRPaper> selectByHremployeeid(String employeeid) ;
    void removeByHremployeeid(String employeeid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRPaper> getHrpaperByIds(List<String> ids) ;
    List<HRPaper> getHrpaperByEntities(List<HRPaper> entities) ;
}


